﻿#SingleInstance Force

#Include ../Class_Gdip.ahk

OnExit("ExitFunc")
oGdip := new _GDIP()
; Get the dimensions of the primary monitor
; these funcs are based off MDMF lib and are now included in the Gdip_All library 
WALeft := 0
WATop := 0
WARight := A_ScreenWidth
WABottom := A_ScreenHeight
WAWidth := A_ScreenWidth
WAHeight := A_ScreenHeight

; Create a gdi bitmap with width and height of the work area
oHBitmap := new GDIP_HBitmap(WAWidth, WAHeight)
oGraphics := new GDIP_Graphics(oHBitmap)

; Set the smoothing mode to antialias = 4 to make shapes appear smother (only used for vector drawing and filling)
oGraphics.GdipSetSmoothingMode(4)

oBrush := new GDIP_Brush(0xffffffff)
oGraphics.GdipFillRectangle(oBrush.ptr, [0,0,w,h])

oGui := GuiCreate("-Caption +E0x80000 +LastFound +AlwaysOnTop +ToolWindow +OwnDialogs")
oGui.Show("NA")

oGraphics.UpdateLayeredWindow(oGui.hwnd, [0, 0, A_ScreenWidth, A_ScreenHeight])

; Set a timer to draw a new ellipse every 200ms
SetTimer "DrawCircle", 200
return

;#######################################################################

DrawCircle() {
    global
    ; Get a random colour for the background and foreground of hatch style used to fill the ellipse,
    ; as well as random brush style, x and y coordinates and width/height

    RandBackColour := Random(0.0, 0xffffffff)
    RandForeColour := Random(0.0, 0xffffffff)
    RandBrush := Random(0, 53)
    RandElipseWidth := Random(1, 200)
    RandElipseHeight := Random(1, 200)
    RandElipsexPos := Random(WALeft, WAWidth-RandElipseWidth)
    RandElipseyPos := Random(WATop, WAHeight-RandElipseHeight)

    ; Create the random brush
    oBrush.GdipCreateHatchBrush(RandForeColour, RandBackColour, RandBrush)
    oGraphics.GdipFillEllipse(oBrush.ptr, [RandElipsexPos,RandElipseyPos,RandElipseWidth,RandElipseHeight])

    oGraphics.UpdateLayeredWindow(oGui.hwnd, [WALeft, WATop, WAWidth, WAHeight])

    ; Delete the brush as it is no longer needed and wastes memory
    ; Gdip_DeleteBrush(pBrush)
}

;#######################################################################

ExitFunc(ExitReason, ExitCode) { ;NOTE 保证退出顺序
   global
   oBrush := ""
   oHBitmap := ""
   oGraphics := ""
   oGdip := ""
}
