﻿; gdi+ ahk tutorial 6 written by tic (Tariq Porter)
; Requires Gdip.ahk either in your Lib folder as standard library or using #Include
;
; Example to take files from disk, load them onto a background and save back to disk

#SingleInstance Force
;#NoEnv
;SetBatchLines -1

; Uncomment if Gdip.ahk is not in your standard library
#Include ../Gdip_All.ahk

; Specify both of the files we are going to use
File1 := "needle.png"
File2 := "bs.jpg"

; Start gdi+
If !pToken := Gdip_Startup()
{
	MsgBox "Gdiplus failed to start. Please ensure you have gdiplus on your system"
	ExitApp
}

; If the images we want to work with do not exist on disk, then download them...
If !(FileExist(File1) && FileExist(File2))
{
	MsgBox "Cannot find files 'needle.png' and 'background.png' in this same directory"
	ExitApp
}


; Create a pixel gdi+ bitmap (this will be the entire drawing area we have to play with)
;创建空白总图片
pBitmap := Gdip_CreateBitmap(500, 500)

; Get a pointer to the graphics of the bitmap, for use with drawing functions
pGraphics := Gdip_GraphicsFromImage(pBitmap)

; Create a green brush (this will be used to fill the background with green). The brush is fully opaque (ARGB)
;背景
pBrush := Gdip_BrushCreateSolid(0xff00ff00)
Gdip_FillRectangle(pGraphics, pBrush, 0, 0, 600, 600)
Gdip_DeleteBrush(pBrush)

pBitmapFile1 := Gdip_CreateBitmapFromFile(File1)
w := Gdip_GetImageWidth(pBitmapFile1)
h := Gdip_GetImageHeight(pBitmapFile1)
Gdip_DrawImage(pGraphics, pBitmapFile1, 25, 25, w, h, 0, 0, w, h)
Gdip_DisposeImage(pBitmapFile1)

pBitmapFile2 := Gdip_CreateBitmapFromFile(File2)
w := Gdip_GetImageWidth(pBitmapFile2)
h := Gdip_GetImageHeight(pBitmapFile2)
Gdip_DrawImage(pGraphics, pBitmapFile2, 250, 260, w, h, 0, 0, w, h)
Gdip_DisposeImage(pBitmapFile2)

; Save the bitmap to file "File.png" (extension can be .png,.bmp,.jpg,.tiff,.gif)
; Bear in mind transparencies may be lost with some image formats and will appear black
Gdip_SaveBitmapToFile(pBitmap, "FinalImage.png")

;MsgBox "Image saved as 'FinalImage.png' "
run("FinalImage.png")

Gdip_DisposeImage(pBitmap)
Gdip_DeleteGraphics(pGraphics)
Gdip_Shutdown(pToken)
ExitApp

F12::ExitApp
